=begin

Copyright 2010, Reinhart Viane 

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Plugin Name:	DefaultScenes
Version:		1.1
Description:	Automatically creates default scenes
Author:			Reinhart Viane
Date :			2010-09-16
Version information:
* Front-Back-Left-Right-Top-Bottom in parallel projection, ISO in perspective
=end
require 'sketchup.rb'
#pluginsmenu
UI.menu("Plugins").add_item("Default Scenes") { DEFSCENES.execute }
module DEFSCENES
	def DEFSCENES.execute
	model=Sketchup.active_model
	existing_pages=[]
	model.pages.each{|p|
		existing_pages<<p.name.to_s
	}
	views=['TopView','BottomView','FrontView','BackView','LeftView','RightView','IsoView']
	views.each{|view|
		#if the view is already created
		if existing_pages.include?(view)
			if Sketchup.active_model.options['PageOptions']['ShowTransition']==true
				Sketchup.active_model.options['PageOptions']['ShowTransition']=false
				optionchanged=1
			end
			model.pages.selected_page=model.pages[view]
			model.active_view.zoom_extents
			model.pages.selected_page.update
			if optionchanged==1
				Sketchup.active_model.options['PageOptions']['ShowTransition']=true
			end
		else
			if view=='TopView'
				direction = Z_AXIS.reverse
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = false
				model.active_view.zoom_extents
			elsif view=='BottomView'
				direction = Z_AXIS
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = false
				model.active_view.zoom_extents
			elsif view=='FrontView'
				direction = Y_AXIS
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = false
				model.active_view.zoom_extents
			elsif view=='BackView'
				direction = Y_AXIS.reverse
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = false
				model.active_view.zoom_extents
			elsif view=='LeftView'
				direction=X_AXIS
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = false
				model.active_view.zoom_extents
			elsif view=='RightView'
				direction=X_AXIS.reverse
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = false
				model.active_view.zoom_extents
			elsif view=='IsoView'
				direction=Geom::Vector3d.new -0.666667, 0.666667, -0.333333
				model.active_view.camera.set( ORIGIN, direction, direction.axes.y)
				model.active_view.camera.perspective = true
				model.active_view.zoom_extents
			end
			#add page
			model.pages.add view
		end
	}
	end
end
